/*

** array.d

** Copyright (C) 2003 Helmut Leitner

** Donated to Digital Mars.

** Released under the GNU GPL, see LICENSE.TXT

** and http://www.gnu.org/copyleft/gpl.html

*/



module venus.array;

import venus.all;



struct Tpari {

    void *p;

    TypeMethods *ptm;

    int elsize;

    int length;

}



Tpari ArrayRetTpari(inout char [] ar) {

    Tpari ret;

    ret.p=ar;

    ret.length=ar.length;

    ret.ptm= &char_Methods;

    ret.elsize= (*ret.ptm.retsize)();

    return ret;

}



Tpari ArrayRetTpari(inout double [] ar) {

    Tpari ret;

    ret.p=ar;

    ret.length=ar.length;

    ret.ptm= &double_Methods;

    ret.elsize= (*ret.ptm.retsize)();

    return ret;

}



void MemSwap(void *p1,void *p2,int size) {

  byte t;

  while(size-- > 0) {

    t=*(byte *)p1;

    *(byte *)p1=*(byte *)p2;

    *(byte *)p2=t;

    p1++; p2++;

  }

}



void MemArraySwapInd(void *p,int size,int ind1,int ind2) {

//  Print("Swap: "); Print(ind1); PrintLine("<->",ind2);

  MemSwap(ind1*size+(byte *)p,ind2*size+(byte *)p,size);

}



void MemLengthCvtRandom(void *p,int size,int length) {

  int ind1=0;

  int ind2=length-1;

  int ind;



  while(ind2 > ind1) {

    ind = Random.RetIntRange(ind1, ind2);

    MemArraySwapInd(p,size,ind,ind2);

    ind2--;

  }

}



void TpariCvtRandom(Tpari tpari) {

  MemLengthCvtRandom(tpari.p,tpari.elsize,tpari.length);

}



void ArrayCvtRandom(Object [] ar) {

  int length=ar.length;

  int elsize=ar[0].size;

  void *p=ar;

  MemLengthCvtRandom(p,elsize,length);

}



void ArrayCvtRandom(char [] ar)   { TpariCvtRandom(ArrayRetTpari(ar)); }

void ArrayCvtRandom(double [] ar) { TpariCvtRandom(ArrayRetTpari(ar)); }





